pipeline {
  environment {
    registry = "9538603484/fery_restaurant"
    registryCredential = 'docker_hub'
    dockerImage = ''
  }
agent any
stages {
 stage('git') {
  steps {
      echo 'checkout code from gitlab'
git credentialsId: 'gitlab', url: 'http://15.206.126.189:8085/Jagadeesh.S/fery-restaurant.git'
      }
    }
   stage('npm install package'){
    steps{
      echo "installing the npm package "
          sh '''
          rm -rf node_modules package-lock.json
          
         
         
          npm install --unsafe-perm

         

          curl -sL https://deb.nodesource.com/setup_12.x | sudo -E bash -
          
          sudo apt-get install -y nodejs

          sudo npm install npm@latest -g

          '''
         }
       }
      
    stage('Build docker image'){
      steps{
        echo "Building docker image"
        script{
          dockerImage = docker.build registry + ":$BUILD_NUMBER"
        }
      }
    }

   stage ('Push Docker Image') {
      steps{
        echo "Pushing Docker Image"
        script {
          docker.withRegistry( '', registryCredential ) {
              dockerImage.push()
              dockerImage.push('latest')
          }
        }
      }
    }
  
  
    stage ('Deploy to dev Environment') {
      steps{
        echo "deploying to dev environment"
        
     sh "docker rm -f ferry_restaurant || true"
     sh " docker run -d --name=ferry_restaurant -p 8082:8081 9538603484/restaurant"    
              
        
        }
      }  
  }
}